USE [_toolDB]
GO
/****** Object:  StoredProcedure [dbo].[get_used_SSIS_DFT_controls]   ******/
CREATE PROC [dbo].[get_used_SSIS_DFT_controls]  -- 'C:\_transport\11_Pack_Clean_Verkaufszahlen.dtsx'
            @file  varchar(255)
AS
BEGIN

--SET     @file = 'C:\<folder>\<file>.dtsx'

Declare @charVar varChar(max)
      , @nameSp  varChar(400)
   , @sqlCmd  varChar(400)
   , @xmlVar  xml

Declare @tmpTable Table (col1 varchar(max))
Set @sqlCmd  = ' Select * From OPENROWSET ( BULK ''' + @file + ''', SINGLE_BLOB ) AS x ';

Insert Into @tmpTable
exec( @sqlCmd )

Set  @xmlVar = ( select Top(1) col1 from @tmpTable );
---- select @xmlVar
----

Declare @i int;  -- idoc

Execute sp_xml_preparedocument @i OutPut
                             , @xmlVar
        , '<DTS:Executable xmlns:DTS="www.microsoft.com/SqlServer/Dts"/>'
       
---- Executables ------------------------------------------------------------
SELECT  T.Task_name
      , p.*
FROM  (
		---- DFT TASK & CONTROLS
		SELECT *
		FROM   OpenXML ( @i, '/DTS:Executable/DTS:Executables/DTS:Executable/DTS:ObjectData/pipeline/components/component' )
		WITH  ( Task_name          nvarChar(100)  '../../../../@DTS:ObjectName'
			  , control_name       nvarChar(100)  '@name'   -- component  -- ok
		--      Task_name          nvarChar(100)  '../../../../../../@DTS:ObjectName'  -- ok
			  )
      ) T
JOIN
      (
		---- ..components 
		SELECT *
		FROM   OpenXML ( @i, '/DTS:Executable/DTS:Executables/DTS:Executable/DTS:ObjectData/pipeline/components/component' )
		WITH  ( control_name     nvarChar(100)  '@name'
			  --, prop_name        nvarChar(100)  '../@name'
			  --, property         nvarChar(400)  'property'
			  )

      ) p
ON      T.control_name = p.control_name


Execute sp_xml_removedocument @i


END  -- end Proc
GO
/****** Object:  StoredProcedure [dbo].[get_used_SSIS_DFT_path_names]   ******/
CREATE PROC [dbo].[get_used_SSIS_DFT_path_names]   -- 'C:\_transport\11_Pack_Clean_Verkaufszahlen.dtsx'
            @file  varchar(255)
AS
BEGIN

Declare @charVar varChar(max)
      , @nameSp  varChar(400)
   , @sqlCmd  varChar(400)
   , @xmlVar  xml

Declare @tmpTable Table (col1 varchar(max))
Set @sqlCmd  = ' Select * From OPENROWSET ( BULK ''' + @file + ''', SINGLE_BLOB ) AS x ';

Insert Into @tmpTable
exec( @sqlCmd )

Set  @xmlVar = ( select Top(1) col1 from @tmpTable );
---- select @xmlVar
----

Declare @i int;  -- idoc

Execute sp_xml_preparedocument @i OutPut
                             , @xmlVar
        , '<DTS:Executable xmlns:DTS="www.microsoft.com/SqlServer/Dts"/>'
       
---- Executables ------------------------------------------------------------

---- DFT TASK & CONTROLS
SELECT *

     --  CAST( Left(path_name,2) as Int) as 'control_no'
     --, SUBSTRING( path_name, 10, 100)  as 'DFT_control'
     --, *
FROM   OpenXML ( @i, '/DTS:Executable/DTS:Executables/DTS:Executable/DTS:ObjectData/pipeline/paths/path' )
WITH  ( Task_name          nvarChar(100)  '../../../../@DTS:ObjectName'
	  , path_name          nvarChar(100)  '@name'   -- component  -- ok
    , startId            nvarChar(100)  '@startId'  
    , endId              nvarChar(100)  '@endId'
	  )
    
Execute sp_xml_removedocument @i

END  -- end Proc
----------------------------------------------
 
GO
/****** Object:  StoredProcedure [dbo].[get_used_SSIS_Variables]     ******/
CREATE PROC [dbo].[get_used_SSIS_Variables]  -- 'C:\_transport\11_Pack_Clean_Verkaufszahlen.dtsx'
            @file  varchar(255)
AS
BEGIN

Declare @charVar varChar(max)
      , @nameSp  varChar(400)
      , @sqlCmd  varChar(400)
      , @xmlVar  xml

Declare @tmpTable Table (col1 varchar(max))
Set @sqlCmd  = ' Select * From OPENROWSET ( BULK ''' + @file + ''', SINGLE_BLOB ) AS x ';

Insert Into @tmpTable
exec( @sqlCmd )

Set  @xmlVar = ( select Top(1) col1 from @tmpTable );
--select @xmlVar
----

Declare @i int;  -- idoc

Execute sp_xml_preparedocument @i OutPut
                             , @xmlVar
        , '<DTS:Executable xmlns:DTS="www.microsoft.com/SqlServer/Dts"/>'
       
---- Variables ------------------------------------------------------------
SELECT @file                                                                       as 'flName'
     --, Props.Prop.query('.')
     , Props.Prop.value('declare namespace n1="www.microsoft.com/SqlServer/Dts";
	                     string(./../@n1:ObjectName)','nvarchar(max)')             as 'Variable'
     , Props.Prop.value('declare namespace n1="www.microsoft.com/SqlServer/Dts";
	                     string(./../@n1:Namespace)','nvarchar(max)')              as 'Namespace'
     , Props.Prop.value('declare namespace n1="www.microsoft.com/SqlServer/Dts";
	                     string(./@n1:DataType)','nvarchar(max)')                  as 'DataType'
     , Props.Prop.value('.', 'nvarchar(max)')                                      as 'DefaultValue'
FROM   @xmlVar.nodes('declare namespace DTS="www.microsoft.com/SqlServer/Dts";
                      /DTS:Executable/DTS:Variables/DTS:Variable/DTS:VariableValue') Props(Prop)

Execute sp_xml_removedocument @i


END  -- end proc
GO
