USE [_toolDB]
GO

/****** Object:  Table [config].[SSISDB_catalog_properties]    Script Date: 7/3/2014 2:49:17 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [config].[SSISDB_catalog_properties](
	[ID] [int]        IDENTITY(1,1) NOT NULL,
	[property_name]   nvarchar(256) NULL,
	[property_value]  nvarchar(256) NULL,
	[config_since]    datetime NULL,
	[config_to]       datetime NULL,
 CONSTRAINT [PK_SSISDB_catalog_properties] PRIMARY KEY CLUSTERED 
           ( [ID] ASC )
) ON [PRIMARY]

GO

------------
CREATE  PROC [config].[usp_check_SSISDB_catalog_properties]
             @inserted  int = 0 OUTPUT
           , @updated   int = 0 OUTPUT
AS
BEGIN

DECLARE @DateTime   datetime = GetDate()
DECLARE @MergeAudit Table(
        ACTION          nvarchar(20)
      , property_name   nvarchar(256) 
	  , property_value  nvarchar(256) 
	  )

MERGE
INTO   _toolDB.config.SSISDB_catalog_properties  target
USING  SSISDB.catalog.catalog_properties         source
ON  (  target.property_name = source.property_name 
                              collate Latin1_General_CI_AS )

WHEN   NOT MATCHED By target
THEN
       INSERT( property_name, property_value, config_since )
	   VALUES( property_name, property_value, @DateTime    )

WHEN   MATCHED
AND  ( target.config_to       IS  NULL                  )
AND  ( target.property_value  !=  source.property_value 
                                  collate Latin1_General_CI_AS)
THEN
       UPDATE
	   SET    target.config_to = @DateTime
	   -- + INSERT "new version"
	   
OUTPUT $ACTION
     , source.property_name    
	 , source.property_value
INTO   @MergeAudit
; --   end MERGE	 	    

-- + INSERT "new version"
INSERT INTO _toolDB.config.SSISDB_catalog_properties
      ( property_name, property_value, config_since )
SELECT  property_name, property_value, @DateTime
FROM    @MergeAudit
WHERE   ACTION = 'UPDATE'

SET @inserted = ( select count(*) from @MergeAudit where ACTION = 'INSERT' )
SET @updated  = ( select count(*) from @MergeAudit where ACTION = 'UPDATE' )

SELECT @inserted as 'inserted'
     , @updated  as 'updated'

END  -- end PROC